﻿'Socketクラスの呼び出し
Imports System
Imports System.Text
Imports System.IO
Imports System.Net
Imports System.Net.Sockets
Imports Microsoft.VisualBasic

Public Class TCP通信
    '共通変数の定義
    Dim Temp As Long
    Dim Ondo As Double
    Dim Humi As Double
    Dim Pres As Double
    '送信コマンドデータ定義
    Dim SWInput As Byte() = Encoding.ASCII.GetBytes("SBE")
    Dim LED1On As Byte() = Encoding.ASCII.GetBytes("SC11E")
    Dim LED1Off As Byte() = Encoding.ASCII.GetBytes("SC10E")
    Dim LED2On As Byte() = Encoding.ASCII.GetBytes("SC21E")
    Dim LED2Off As Byte() = Encoding.ASCII.GetBytes("SC20E")
    Dim Mesure As Byte() = Encoding.ASCII.GetBytes("SAE")
    Dim Shut As Byte() = Encoding.ASCII.GetBytes("SNE")

    'TCPクライアントクラスとNetworkStreamクラスのインスタンス生成
    Dim TcpClientA As New TcpClient()
    Dim MyStream As NetworkStream
    Dim Flag As Integer
    Dim RcvBuf(31) As Byte

    Private Sub TCP通信_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Timer1.Enabled = False
        Timer2.Enabled = False
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Try
            TcpClientA.Connect(TextBox1.Text, Integer.Parse(TextBox2.Text))
            MyStream = TcpClientA.GetStream()
            TextBox3.Text = "接続成功!"
            Flag = 0
            Timer2.Interval() = 5       '5msecタイマ起動
            Timer2.Enabled() = True     'タイマ2起動
        Catch ex As Exception
            TextBox3.Text = "接続失敗??"
        End Try
    End Sub


    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        'End送信
        If TcpClientA.Connected = True Then
            MyStream.Write(Shut, 0, Shut.Length)
            MyStream.Close()            'ストリームクローズ
            TcpClientA.Close()          'TCPのクローズ
        End If
        Timer1.Enabled = False          'タイマ１停止
        Timer2.Enabled = False          'タイマ２停止
        Close()
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        '現在状態によりオンオフを反転制御
        If Button3.Text = "Off" Then
            MyStream.Write(LED1On, 0, LED1On.Length)
        Else
            MyStream.Write(LED1Off, 0, LED1Off.Length)
        End If
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        '現在状態によりオンオフを反転制御
        If Button4.Text = "On" Then
            MyStream.Write(LED2Off, 0, LED2Off.Length)
        Else
            MyStream.Write(LED2On, 0, LED2On.Length)
        End If
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        'スイッチ状態入力コマンド送信
        MyStream.Write(SWInput, 0, SWInput.Length)
    End Sub

    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        '計測周期要求
        If Timer1.Enabled = False Then
            Timer1.Interval() = 3000     '3000msecタイマ起動
            Timer1.Enabled() = True     'タイマ１起動
            Button6.Text = "停止"
        Else
            Timer1.Enabled = False
            Button6.Text = "計測"
        End If
        ProgressBar1.Maximum = 1024
        ProgressBar1.Minimum = 0
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        '計測要求
        MyStream.Write(Mesure, 0, Mesure.Length)
    End Sub

    Private Sub Timer2_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer2.Tick
        Dim i As Integer
        Dim j As Integer
        Dim Buffer(32) As Byte
        Dim data As Integer

        'TCP受信
        If TcpClientA.Available > 0 Then
            MyStream.Read(RcvBuf, 0, RcvBuf.Length)

            '最初のMを見つける
            i = 0
            While ((RcvBuf(i) <> &H4D) And (i < RcvBuf.Length - 1))
                i = i + 1
            End While
            If ((i < RcvBuf.Length - 1) Or (RcvBuf(RcvBuf.Length - 1) = &H4D)) Then                       '見つかった場合
                For j = 0 To RcvBuf.Length - 1              'バッファにデータ転送
                    Buffer(j) = RcvBuf(i)
                    If i = RcvBuf.Length - 1 Then           '循環で32バイトのみ転送
                        i = 0
                    Else
                        i = i + 1
                    End If
                Next
                TextBox3.Text = ""
                ' ********** データごとの処理実行 ************
                '状態データ要求の応答の場合
                If Buffer(1) = &H42 Then                    'Bの場合
                    'Xが0か1でオンオフ表示制御
                    If Buffer(2) = &H30 Then
                        TextBox4.BackColor = Color.Red
                    Else
                        TextBox4.BackColor = Color.Green
                    End If
                    If Buffer(3) = &H30 Then
                        TextBox5.BackColor = Color.Red
                    Else
                        TextBox5.BackColor = Color.Green
                    End If
                    If Buffer(4) = &H30 Then
                        TextBox6.BackColor = Color.Red
                    Else
                        TextBox6.BackColor = Color.Green
                    End If
                    If Buffer(5) = &H30 Then
                        TextBox7.BackColor = Color.Red
                    Else
                        TextBox7.BackColor = Color.Green
                    End If
                    ' 制御要求の応答の場合
                ElseIf Buffer(1) = &H43 Then                    'Cの場合
                    If Buffer(2) = &H31 Then                    '出力1の場合
                        'オンオフ状態により色とテキストを変更
                        If Buffer(3) = &H31 Then
                            Button3.BackColor = Color.Red
                            Button3.Text = "On"
                        Else
                            Button3.BackColor = Color.Green
                            Button3.Text = "Off"
                        End If
                    ElseIf Buffer(2) = &H32 Then                '出力2の場合
                        'オンオフ状態により色とテキストを変更
                        If Buffer(3) = &H31 Then
                            Button4.BackColor = Color.Red
                            Button4.Text = "On"
                        Else
                            Button4.BackColor = Color.Green
                            Button4.Text = "Off"
                        End If
                    End If
                    ' 計測要求の応答の場合
                ElseIf Buffer(1) = &H41 Then                    'Aの場合
                    'データ変換と表示
                    Temp = Buffer(3) * 256 + Buffer(4)
                    Ondo = 0.01 * Temp - 39.7
                    TextBox8.Text = Ondo.ToString("F1")
                    '計測データ変換と表示
                    Temp = Buffer(6) * 256 + Buffer(7)
                    Humi = 0.0367 * Temp - 2.048
                    Humi += (Ondo - 25.9) * (0.01 + 0.00008 * Temp)
                    TextBox9.Text = Humi.ToString("F1")
                    '計測データ変換と表示
                    Temp = Buffer(9) * 256 + Buffer(10)
                    Pres = Temp / 10.0
                    TextBox10.Text = Pres.ToString("F1")
                    '計測データ変換と表示
                    Temp = Buffer(11) * 256 + Buffer(12)
                    If (Temp < 1024) Then
                        ProgressBar1.Value = Temp
                    End If
                    data = Buffer(13) * 256 + Buffer(14)
                    TextBox11.Text = data.ToString("F1")
                    data = Buffer(15) * 256 + Buffer(16)
                    TextBox12.Text = data.ToString("F1")
                    data = Buffer(17) * 256 + Buffer(18)
                    TextBox13.Text = data.ToString("F1")
                    data = Buffer(19) * 256 + Buffer(20)
                    TextBox14.Text = data.ToString("F1")
                    'どれでもない場合
                Else
                    TextBox3.Text = "受信合致なし？？？"
                End If
            End If
        End If
    End Sub
End Class
